Index: /trunk/Cosmo/SimLSS/Makefile
===================================================================
--- /trunk/Cosmo/SimLSS/Makefile	(revision 3520)
+++ /trunk/Cosmo/SimLSS/Makefile	(revision 3521)
@@ -11,27 +11,32 @@
 
 MYEXTINC = ${EXTLIBDIR}/Include
-#MYLIB = $(SOPHYAEXTSLBLIST) -L$(LIB) -lcmvsimbao -lfftw3 -lm
-MYLIB = $(SOPHYAEXTSLBLIST) -L$(LIB) -lcmvsimbao -lfftw3_threads -lfftw3f_threads -lfftw3 -lfftw3f -lm
+MYLIB  = $(SOPHYAEXTSLBLIST) -L$(LIB) -lcmvsimbao -lcmvgenfluc -lfftw3_threads -lfftw3 -lm
+MYLIB4 = $(SOPHYAEXTSLBLIST) -L$(LIB) -lcmvsimbao -lcmvgenfluc4 -lfftw3f_threads -lfftw3f -lm
 
 #--------------------------------------------------------------------------
 # ---- Les programmes de simulation
 PROGS = \
+       $(EXE)cmvobserv3d $(EXE)cmvobserv3df \
        $(EXE)cmvtuniv $(EXE)cmvtransf $(EXE)cmvtgrowth $(EXE)cmvtstpk \
-       $(EXE)cmvtstsch $(EXE)cmvtstblack $(EXE)cmvtvarspec \
-       $(EXE)cmvdefsurv $(EXE)cmvobserv3d $(EXE)cmvtintfun \
-       $(EXE)cmvconcherr $(EXE)cmvtinterp $(EXE)cmvtstagn $(EXE)cmvschdist
+       $(EXE)cmvtstsch $(EXE)cmvtstblack $(EXE)cmvtvarspec $(EXE)cmvdefsurv \
+       $(EXE)cmvtintfun $(EXE)cmvconcherr $(EXE)cmvtinterp $(EXE)cmvtstagn \
+       $(EXE)cmvschdist
  
 PROGSOBJ = \
+          $(OBJ)cmvobserv3d.o $(OBJ)cmvobserv3df.o \
           $(OBJ)cmvtuniv.o $(OBJ)cmvtransf.o $(OBJ)cmvtgrowth.o $(OBJ)cmvtstpk.o \
           $(OBJ)cmvtstsch.o $(OBJ)cmvtstblack.o $(OBJ)cmvtvarspec.o $(OBJ)cmvdefsurv.o \
-          $(OBJ)cmvobserv3d.o $(OBJ)cmvtintfun.o $(OBJ)cmvtinterp.o \
+          $(OBJ)cmvtintfun.o $(OBJ)cmvtinterp.o \
           $(OBJ)cmvconcherr.o $(OBJ)cmvtluc.o $(OBJ)cmvtstagn.o $(OBJ)cmvschdist.o
  
 LIBROBJ = \
           $(OBJ)cosmocalc.o $(OBJ)pkspectrum.o $(OBJ)schechter.o \
-          $(OBJ)planckspectra.o $(OBJ)geneutils.o $(OBJ)agnjackson.o \
-          $(OBJ)genefluct3d.o
-
-LIBR = $(LIB)libcmvsimbao.a
+          $(OBJ)planckspectra.o $(OBJ)geneutils.o $(OBJ)agnjackson.o
+LIBGOBJ = $(OBJ)genefluct3d.o
+LIBGOBJ4 = $(OBJ)genefluct3df.o
+
+LIBR  = $(LIB)libcmvsimbao.a
+LIBG  = $(LIB)libcmvgenfluc.a
+LIBG4 = $(LIB)libcmvgenfluc4.a
 
 #--------------------------------------------------------------------------
@@ -57,5 +62,5 @@
 all: lib prog
 
-lib: $(LIBR)
+lib: $(LIBR) $(LIBG) $(LIBG4)
 
 prog: $(PROGS)
@@ -71,4 +76,6 @@
 	rm -f $(PROGS) $(PROGSOBJ)
 	rm -f $(LIBR) $(LIBROBJ)
+	rm -f $(LIBG) $(LIBGOBJ)
+	rm -f $(LIBG4) $(LIBGOBJ4)
 	rm -rf $(OBJ)/CmvBAO_cxxrep/
 	rm -f $(PROGSTEST) $(PROGSTESTOBJ)
@@ -78,5 +85,4 @@
 $(LIB)libcmvsimbao.a : $(LIBROBJ)
 	$(AR) $(ARFLAGS) $@ $? 
-
 $(OBJ)cosmocalc.o: cosmocalc.cc cosmocalc.h constcosmo.h
 	$(CXXCOMPILE) $(CXXREP) -I$(MYEXTINC) -o $@ cosmocalc.cc
@@ -91,6 +97,14 @@
 $(OBJ)agnjackson.o: agnjackson.cc agnjackson.h
 	$(CXXCOMPILE) $(CXXREP) -I$(MYEXTINC) -o $@ agnjackson.cc
+
+$(LIB)libcmvgenfluc.a : $(LIBGOBJ)
+	$(AR) $(ARFLAGS) $@ $? 
 $(OBJ)genefluct3d.o: genefluct3d.cc genefluct3d.h
 	$(CXXCOMPILE) $(CXXREP) -I$(MYEXTINC) -o $@ genefluct3d.cc
+
+$(LIB)libcmvgenfluc4.a : $(LIBGOBJ4)
+	$(AR) $(ARFLAGS) $@ $? 
+$(OBJ)genefluct3df.o: genefluct3d.cc genefluct3d.h
+	$(CXXCOMPILE) $(CXXREP) -I$(MYEXTINC) -DGEN3D_FLOAT -o $@ genefluct3d.cc
 
 ##############################################################################
@@ -165,4 +179,11 @@
 $(OBJ)cmvobserv3d.o: cmvobserv3d.cc
 	$(CXXCOMPILE) $(CXXREP) -I$(MYEXTINC) -o $@ cmvobserv3d.cc
+
+cmvobserv3df: $(EXE)cmvobserv3df
+	echo $@ " done"
+$(EXE)cmvobserv3df: $(OBJ)cmvobserv3df.o $(LIBR)
+	$(CXXLINK) $(CXXREP) -o $@ $(OBJ)cmvobserv3df.o $(MYLIB4) 
+$(OBJ)cmvobserv3df.o: cmvobserv3d.cc
+	$(CXXCOMPILE) $(CXXREP) -I$(MYEXTINC) -DGEN3D_FLOAT -o $@ cmvobserv3d.cc
 
 ##############################################################################
Index: /trunk/Cosmo/SimLSS/genefluct3d.cc
===================================================================
--- /trunk/Cosmo/SimLSS/genefluct3d.cc	(revision 3520)
+++ /trunk/Cosmo/SimLSS/genefluct3d.cc	(revision 3521)
@@ -142,5 +142,9 @@
 void GeneFluct3D::setalloc(void)
 {
- if(lp_>1) cout<<"--- GeneFluct3D::setalloc ---"<<endl;
+#if defined(GEN3D_FLOAT)
+ if(lp_>1) cout<<"--- GeneFluct3D::setalloc FLOAT ---"<<endl;
+#else
+ if(lp_>1) cout<<"--- GeneFluct3D::setalloc DOUBLE ---"<<endl;
+#endif
  // Dimensionnement du tableau complex<r_8>
  // ATTENTION: TArray adresse en memoire a l'envers du C
Index: /trunk/Cosmo/SimLSS/genefluct3d.h
===================================================================
--- /trunk/Cosmo/SimLSS/genefluct3d.h	(revision 3520)
+++ /trunk/Cosmo/SimLSS/genefluct3d.h	(revision 3521)
@@ -19,5 +19,6 @@
 
 #define WITH_FFTW_THREAD
-//#define GEN3D_FLOAT
+
+//NE PAS DECOMMENTER, UTILISEZ LA MAKEFILE #define GEN3D_FLOAT
 
 #if defined(GEN3D_FLOAT)