Index: /trunk/SophyaPI/PIext/graphexecut.cc
===================================================================
--- /trunk/SophyaPI/PIext/graphexecut.cc	(revision 3527)
+++ /trunk/SophyaPI/PIext/graphexecut.cc	(revision 3528)
@@ -419,5 +419,5 @@
 usage += "                midas_pastel midas_heat midas_rainbow3 midas_bluered\n";
 usage += "                midas_bluewhite midas_redwhite\n";
-usage += "                multicol16 multicol64\n";
+usage += "                multicol16 multicol64 rgb216cm rgb512cm rgb4096cm\n";
 usage += ">> revcmap : reverse colorMap\n";
 usage += ">> ZoomFactors :  zoomxN   ex: zoomx1 zoomx2 zoomx3 ...\n";
@@ -425,5 +425,5 @@
 usage += ">> imagecenter=ix,iy : Position the image in widget\n";
 usage += ">> lut=ltyp,min,max : Sets LUT type and min/max\n";
-usage += "                   (ltyp=lin/log/sqrt/square)\n";
+usage += "                   (ltyp=lin/log/sqrt/square/rgb)\n";
 usage += ">> autolut=alt[,ns[,min,max]] : AutoLut method selection \n";
 usage += "                   (alt=minmax/meansig/hispeak/histail/hisrng)\n";
Index: /trunk/SophyaPI/PIext/nomtarradapter.cc
===================================================================
--- /trunk/SophyaPI/PIext/nomtarradapter.cc	(revision 3527)
+++ /trunk/SophyaPI/PIext/nomtarradapter.cc	(revision 3528)
@@ -496,4 +496,6 @@
 #ifdef __CXX_PRAGMA_TEMPLATES__
 #pragma define_template NOMAdapter_TArray<uint_2>
+#pragma define_template NOMAdapter_TArray<uint_4>
+#pragma define_template NOMAdapter_TArray<uint_8>
 #pragma define_template NOMAdapter_TArray<int_2>
 #pragma define_template NOMAdapter_TArray<int_4>
@@ -504,4 +506,6 @@
 #pragma define_template NOMAdapter_TArray< complex<r_8> >
 #pragma define_template NTupInt_TArray<uint_2>
+#pragma define_template NTupInt_TArray<uint_4>
+#pragma define_template NTupInt_TArray<uint_8>
 #pragma define_template NTupInt_TArray<int_2>
 #pragma define_template NTupInt_TArray<int_4>
@@ -515,4 +519,6 @@
 #if defined(ANSI_TEMPLATES) 
 template class NOMAdapter_TArray<uint_2>;
+template class NOMAdapter_TArray<uint_4>;
+template class NOMAdapter_TArray<uint_8>;
 template class NOMAdapter_TArray<int_2>;
 template class NOMAdapter_TArray<int_4>;
@@ -523,4 +529,6 @@
 template class NOMAdapter_TArray< complex<r_8> >;
 template class NTupInt_TArray<uint_2>;
+template class NTupInt_TArray<uint_4>;
+template class NTupInt_TArray<uint_8>;
 template class NTupInt_TArray<int_2>;
 template class NTupInt_TArray<int_4>;
Index: /trunk/SophyaPI/PIext/nomtmatvecadapter.cc
===================================================================
--- /trunk/SophyaPI/PIext/nomtmatvecadapter.cc	(revision 3527)
+++ /trunk/SophyaPI/PIext/nomtmatvecadapter.cc	(revision 3528)
@@ -326,10 +326,11 @@
 AnyDataObj* NOMAdapter_TMatrix<T>::FitResidusObj(GeneralFit& mfit)
 {
+ArrayFitter<T> arrfit;
 TVector<T>* vec = dynamic_cast<TVector<T> *>(mMtx);
 if(vec) {
-  TVector<T>* v = new TVector<T>(ObjectFitter::FitResidus(*vec,mfit),true);
+  TVector<T>* v = new TVector<T>(arrfit.FitResidus(*vec, mfit),true);
   return v;
 } else {
-  TMatrix<T>* m = new TMatrix<T>(ObjectFitter::FitResidus(*mMtx,mfit),true);
+  TMatrix<T>* m = new TMatrix<T>(arrfit.FitResidus(*mMtx,mfit),true);
   return m;
 }
@@ -339,10 +340,11 @@
 AnyDataObj* NOMAdapter_TMatrix<T>::FitFunctionObj(GeneralFit& mfit)
 {
+ArrayFitter<T> arrfit;
 TVector<T>* vec = dynamic_cast<TVector<T> *>(mMtx);
 if(vec) {
-  TVector<T>* v = new TVector<T>(ObjectFitter::FitFunction(*vec,mfit),true);
+  TVector<T>* v = new TVector<T>(arrfit.FitFunction(*vec,mfit),true);
   return v;
 } else {
-  TMatrix<T>* m = new TMatrix<T>(ObjectFitter::FitFunction(*mMtx,mfit),true);
+  TMatrix<T>* m = new TMatrix<T>(arrfit.FitFunction(*mMtx,mfit),true);
   return m;
 }
@@ -493,4 +495,6 @@
 #ifdef __CXX_PRAGMA_TEMPLATES__
 #pragma define_template NOMAdapter_TMatrix<uint_2>
+#pragma define_template NOMAdapter_TMatrix<uint_4>
+#pragma define_template NOMAdapter_TMatrix<uint_8>
 #pragma define_template NOMAdapter_TMatrix<int_2>
 #pragma define_template NOMAdapter_TMatrix<int_4>
@@ -501,4 +505,6 @@
 #pragma define_template NOMAdapter_TMatrix< complex<r_8> >
 #pragma define_template NTupInt_TMatrix<uint_2>
+#pragma define_template NTupInt_TMatrix<uint_4>
+#pragma define_template NTupInt_TMatrix<uint_8>
 #pragma define_template NTupInt_TMatrix<int_2>
 #pragma define_template NTupInt_TMatrix<int_4>
@@ -512,4 +518,6 @@
 #if defined(ANSI_TEMPLATES) 
 template class NOMAdapter_TMatrix<uint_2>;
+template class NOMAdapter_TMatrix<uint_4>;
+template class NOMAdapter_TMatrix<uint_8>;
 template class NOMAdapter_TMatrix<int_2>;
 template class NOMAdapter_TMatrix<int_4>;
@@ -520,4 +528,6 @@
 template class NOMAdapter_TMatrix< complex<r_8> >;
 template class NTupInt_TMatrix<uint_2>;
+template class NTupInt_TMatrix<uint_4>;
+template class NTupInt_TMatrix<uint_8>;
 template class NTupInt_TMatrix<int_2>;
 template class NTupInt_TMatrix<int_4>;
Index: /trunk/SophyaPI/PIext/piinit.cc
===================================================================
--- /trunk/SophyaPI/PIext/piinit.cc	(revision 3527)
+++ /trunk/SophyaPI/PIext/piinit.cc	(revision 3528)
@@ -73,5 +73,8 @@
   serv->RegisterClass(new Matrix, new NOMAdapter_Matrix );
 #else
+//  Octobre 2008 : prise en charge tableaux/matrice/vecteurs en uint_4 uint_8 
   serv->RegisterClass(new TArray<uint_2>, new NOMAdapter_TArray<uint_2> );
+  serv->RegisterClass(new TArray<uint_4>, new NOMAdapter_TArray<uint_4> );
+  serv->RegisterClass(new TArray<uint_8>, new NOMAdapter_TArray<uint_8> );
   serv->RegisterClass(new TArray<int_2>, new NOMAdapter_TArray<int_2> );
   serv->RegisterClass(new TArray<int_4>, new NOMAdapter_TArray<int_4> );
@@ -84,4 +87,8 @@
   serv->RegisterClass(new TVector<uint_2>, new NOMAdapter_TMatrix<uint_2> );
   serv->RegisterClass(new TMatrix<uint_2>, new NOMAdapter_TMatrix<uint_2> );
+  serv->RegisterClass(new TVector<uint_4>, new NOMAdapter_TMatrix<uint_4> );
+  serv->RegisterClass(new TMatrix<uint_4>, new NOMAdapter_TMatrix<uint_4> );
+  serv->RegisterClass(new TVector<uint_8>, new NOMAdapter_TMatrix<uint_8> );
+  serv->RegisterClass(new TMatrix<uint_8>, new NOMAdapter_TMatrix<uint_8> );
   serv->RegisterClass(new TVector<int_2>, new NOMAdapter_TMatrix<int_2> );
   serv->RegisterClass(new TMatrix<int_2>, new NOMAdapter_TMatrix<int_2> );
@@ -103,4 +110,6 @@
       NOMAdapter_Image<T> , deplace ci-dessous dans SANS_EVOLPLANCK */
   serv->RegisterClass(new Image<uint_2>, new NOMAdapter_TMatrix<uint_2> );
+  serv->RegisterClass(new Image<uint_4>, new NOMAdapter_TMatrix<uint_4> );
+  serv->RegisterClass(new Image<uint_8>, new NOMAdapter_TMatrix<uint_8> );
   serv->RegisterClass(new Image<int_2>, new NOMAdapter_TMatrix<int_2> );
   serv->RegisterClass(new Image<int_4>, new NOMAdapter_TMatrix<int_4> );
Index: /trunk/SophyaPI/PIext/pitvmaad.cc
===================================================================
--- /trunk/SophyaPI/PIext/pitvmaad.cc	(revision 3527)
+++ /trunk/SophyaPI/PIext/pitvmaad.cc	(revision 3528)
@@ -135,4 +135,6 @@
 #ifdef __CXX_PRAGMA_TEMPLATES__
 #pragma define_template POTVectorAdapter< uint_2 >
+#pragma define_template POTVectorAdapter< uint_4 >
+#pragma define_template POTVectorAdapter< uint_8 >
 #pragma define_template POTVectorAdapter< int_2 >
 #pragma define_template POTVectorAdapter< int_4 >
@@ -144,4 +146,6 @@
 
 #pragma define_template POTMatrixAdapter< uint_2 >
+#pragma define_template POTMatrixAdapter< uint_4 >
+#pragma define_template POTMatrixAdapter< uint_8 >
 #pragma define_template POTMatrixAdapter< int_2 >
 #pragma define_template POTMatrixAdapter< int_4 >
@@ -155,4 +159,6 @@
 #if defined(ANSI_TEMPLATES)
 template class POTVectorAdapter< uint_2 >;
+template class POTVectorAdapter< uint_4 >;
+template class POTVectorAdapter< uint_8 >;
 template class POTVectorAdapter< int_2 >;
 template class POTVectorAdapter< int_4 >;
@@ -164,4 +170,6 @@
 
 template class POTMatrixAdapter< uint_2 >;
+template class POTMatrixAdapter< uint_4 >;
+template class POTMatrixAdapter< uint_8 >;
 template class POTMatrixAdapter< int_2 >;
 template class POTMatrixAdapter< int_4 >;