Index: trunk/SophyaLib/Samba/bruit.cc
===================================================================
--- trunk/SophyaLib/Samba/bruit.cc	(revision 3510)
+++ trunk/SophyaLib/Samba/bruit.cc	(revision 3533)
@@ -10,5 +10,5 @@
 // #include "rancern.h"
 // #include "hbook.h"
-#ifdef OS_MACOSX
+#ifdef Darwin 
 #include <limits.h>
 #endif
Index: trunk/SophyaLib/Samba/lambdaBuilder.cc
===================================================================
--- trunk/SophyaLib/Samba/lambdaBuilder.cc	(revision 3510)
+++ trunk/SophyaLib/Samba/lambdaBuilder.cc	(revision 3533)
@@ -6,27 +6,29 @@
 /*!
   \class SOPHYA::Legendre
-generate Legendre polynomials : use in two steps : 
-
-a) instanciate Legendre(\f$x\f$, \f$lmax\f$) ; \f$x\f$ is the value for wich Legendre polynomials will be required (usually equal to \f$\cos \theta\f$) and \f$lmax\f$ is the MAXIMUM value of the order of polynomials wich will be required in the following code (all polynomials, from \f$l=0 to lmax\f$, are computed once for all by an iterative formula).
-
-b) get the value of Legendre polynomial for a particular value of \f$l\f$ by calling the method getPl.
-
-*/
-
-
+  \ingroup Samba
+
+ Generate Legendre polynomials. The class usage can be summarized  in two steps as follows:
+
+  a) instanciate Legendre(\f$x\f$, \f$lmax\f$) ; \f$x\f$ is the value for wich Legendre 
+  polynomials will be required (usually equal to \f$\cos \theta\f$) and \f$lmax\f$ is 
+  the MAXIMUM value of the order of polynomials wich will be required. 
+  (All polynomials, from \f$l=0 to lmax\f$, are computed once for all by an recursive formula).
+
+  b) get the value of Legendre polynomial for a particular value of \f$l\f$ by calling the 
+  method getPl.
+
+*/
+
+/*! Constructor, with specification of \b lmax and the \b x value for the polynomials */
 Legendre::Legendre(r_8 x, int_4 lmax) 
 {
-  if (fabs(x) > 1. ) 
-    {
-      throw RangeCheckError("variable for Legendre polynomials must have modules inferior to 1" );
-    }
+  if (fabs(x) > 1. ) {
+    throw RangeCheckError("Legendre::Legendre(x,lmax)  invalid x argument, fabs(x) > 1 !" );
+  }
   x_ = x;
   array_init(lmax);
 }
    
-/*! \fn void SOPHYA::Legendre::array_init(int_4 lmax)
-
-compute all \f$P_l(x,l_{max})\f$ for \f$l=1,l_{max}\f$ 
-*/
+/*! Private method which computes all \f$P_l(x,l_{max})\f$ for \f$l=1,l_{max}\f$ */
 void Legendre::array_init(int_4 lmax)
 {
@@ -35,8 +37,7 @@
   Pl_(0)=1.;
   if (lmax>0) Pl_(1)=x_;
-  for (int k=2; k<Pl_.NElts(); k++)
-    {
+  for (int k=2; k<Pl_.NElts(); k++) {
       Pl_(k) = ( (2.*k-1)*x_*Pl_(k-1)-(k-1)*Pl_(k-2) )/k;
-    }
+  }
 }
 
Index: trunk/SophyaLib/Samba/lambdaBuilder.h
===================================================================
--- trunk/SophyaLib/Samba/lambdaBuilder.h	(revision 3510)
+++ trunk/SophyaLib/Samba/lambdaBuilder.h	(revision 3533)
@@ -6,29 +6,26 @@
 #include "tvector.h" 
 #include "alm.h"
+#include "pexceptions.h"
 
 
 namespace SOPHYA {
 
-/*!  classe pour les polynomes de legendre*/
+/*!  class of Legendre polynomials  */
 class Legendre {
+public :
+  Legendre(r_8 x, int_4 lmax);
 
- public :
-Legendre(r_8 x, int_4 lmax);
+  inline r_8 getPl(int_4 l) const
+  {
+  if (l>lmax_)  {
+    throw RangeCheckError("Legendre::getPl(l) l>lmax -> Instanciate class with greater lmax ...");
+  }
+  return Pl_(l);
+  }
 
-inline r_8 getPl(int_4 l) const
-{
-  if (l>lmax_) 
-    {
-      throw (" illegal call of Legendre::getPl with index greater than lmax, which Legendre Class was instanciated with : instanciate Legendre with a greater lmax... ");
-    }
-return Pl_(l);
-}
+private : 
+  Legendre() {;}   // this is forbidden
 
-
- private : 
-
-Legendre() {;}
-
-void array_init(int_4 lmax);
+  void array_init(int_4 lmax);
 
   r_8 x_;
@@ -39,7 +36,7 @@
 
 
- class LambdaLMBuilder {
+class LambdaLMBuilder {
 
- public:
+public:
 
 LambdaLMBuilder() {}
@@ -103,8 +100,7 @@
 
 
-
 class LambdaWXBuilder : public LambdaLMBuilder
 {
- public:
+public:
 
 