Index: /trunk/SophyaPI/PIext/basexecut.cc
===================================================================
--- /trunk/SophyaPI/PIext/basexecut.cc	(revision 3550)
+++ /trunk/SophyaPI/PIext/basexecut.cc	(revision 3551)
@@ -907,9 +907,11 @@
 void PIABaseExecutor::RegisterCommands()
 {
-string kw, usage, grp;
+string kw, usage, grp, gdesc;
 //--------- Commandes du groupe modules externes
+
 grp = "External Modules";
-string gdesc = "Dynamic load (shared object modules) management command group";
+gdesc = "Dynmamic shared library load (DLL) and external (add-on) module management";
 mpiac->AddHelpGroup(grp, gdesc);
+
 kw = "loadmodule";
 usage = "To load and initialize modules \n  Usage: loadmodule fnameso modulename";
@@ -1190,6 +1192,13 @@
 usage += "\n         projh1d projh2d  projprof fillvec fillmtx "; 
 usage += "\n         fillnt fillgd1 fillgd2 ntloop exptovec ... ";
+mpiac->RegisterHelp(kw, usage, grp);
+
 grp = "Expr. Plotting";
-mpiac->RegisterHelp(kw, usage, grp);
+gdesc = "Compute and plot various (c-syntax) expressions of objects \n";
+gdesc += "Objects are seen as list of structures (n-tuples)\n";
+gdesc += "See ObjectExpressions help item for a list of structure\n";
+gdesc += "fields for the different classes managed by piapp";
+mpiac->AddHelpGroup(grp, gdesc);
+
 kw = "plot2d";
 usage = "Plots (2D) Y=g(Object) vs. X=f(Object) --- Object Variable names (double) :";
Index: /trunk/SophyaPI/PIext/cxxexecutor.cc
===================================================================
--- /trunk/SophyaPI/PIext/cxxexecutor.cc	(revision 3550)
+++ /trunk/SophyaPI/PIext/cxxexecutor.cc	(revision 3551)
@@ -36,4 +36,7 @@
 // On enregistre les nouvelles commandes 
 string hgrp = "CxxExecutorCmd";
+string gdesc = "Commands for c++ codelt on the fly compilation and execution";
+mpiac->AddHelpGroup(hgrp, gdesc);
+
 string usage,kw;
 
Index: /trunk/SophyaPI/PIext/graphexecut.cc
===================================================================
--- /trunk/SophyaPI/PIext/graphexecut.cc	(revision 3550)
+++ /trunk/SophyaPI/PIext/graphexecut.cc	(revision 3551)
@@ -505,4 +505,8 @@
 mpiac->RegisterCommand(kw, usage, this, grp);
 
+grp = "Graphic-Elts";
+gdesc = "Simple graphic objects (lines, circles, text...) creation and display";
+mpiac->AddHelpGroup(grp, gdesc);
+
 kw = "addtext";
 usage = "Adds a text string to the current graphic object";
@@ -519,5 +523,5 @@
 usage += "\n  Related commands: addctext addline addarrow addrect addfrect";
 usage += "\n      addcirc addfcirc addarc addfrac addpoly addfpoly settitle graphicatt";  
-mpiac->RegisterCommand(kw, usage, this, "Graphic-Elts");
+mpiac->RegisterCommand(kw, usage, this, grp);
 
 kw = "addctext";
@@ -528,5 +532,5 @@
 usage += "\n  Related commands: addtext addline addrect ...";
 usage += "\n      (See command addtext and graphicatt for more details)";  
-mpiac->RegisterCommand(kw, usage, this, "Graphic-Elts");
+mpiac->RegisterCommand(kw, usage, this, grp);
 
 kw = "addline";
@@ -539,5 +543,5 @@
 usage += "\n  Related commands: addarrow addtext addrect addfrect ";
 usage += "\n       addmarker addcirc addfcirc addarc addfarc addpoly addfpoly graphicatt";  
-mpiac->RegisterCommand(kw, usage, this, "Graphic-Elts");
+mpiac->RegisterCommand(kw, usage, this, grp);
 
 kw = "addarrow";
@@ -550,5 +554,5 @@
 usage += "\n  Related commands: addline addtext addrect addfrect ";
 usage += "\n       addmarker addcirc addfcirc addarc addfarc addpoly addfpoly graphicatt";  
-mpiac->RegisterCommand(kw, usage, this, "Graphic-Elts");
+mpiac->RegisterCommand(kw, usage, this, grp);
 kw = "addarrow_nc";
 
@@ -562,5 +566,5 @@
 usage += "\n  Related commands: addtext addline addarrow addfrect";
 usage += "\n       addcirc addfcirc addarc addfarc addpoly addfpoly graphicatt";  
-mpiac->RegisterCommand(kw, usage, this, "Graphic-Elts");
+mpiac->RegisterCommand(kw, usage, this, grp);
 
 kw = "addfrect";
@@ -573,5 +577,5 @@
 usage += "\n  Related commands: addtext addline addarrow addrect";
 usage += "\n       addcirc addfcirc addpoly addfpoly graphicatt";  
-mpiac->RegisterCommand(kw, usage, this, "Graphic-Elts");
+mpiac->RegisterCommand(kw, usage, this, grp);
 
 kw = "addmarker";
@@ -584,5 +588,5 @@
 usage += "\n  Related commands: addtext addline addarrow addfrect addfrect";
 usage += "\n       addcirc addfcirc addarc addfarc addpoly addfpoly graphicatt";  
-mpiac->RegisterCommand(kw, usage, this, "Graphic-Elts");
+mpiac->RegisterCommand(kw, usage, this, grp);
 
 kw = "addcirc";
@@ -595,5 +599,5 @@
 usage += "\n  Related commands: addtext addline addarrow addfrect addfrect";
 usage += "\n       addfcirc addarc addfarc addpoly addfpoly graphicatt";  
-mpiac->RegisterCommand(kw, usage, this, "Graphic-Elts");
+mpiac->RegisterCommand(kw, usage, this, grp);
 
 kw = "addfcirc";
@@ -606,5 +610,5 @@
 usage += "\n  Related commands: addtext addline addarrow addfrect addfrect";
 usage += "\n       addcirc addarc addfarc addpoly addfpoly graphicatt";  
-mpiac->RegisterCommand(kw, usage, this, "Graphic-Elts");
+mpiac->RegisterCommand(kw, usage, this, grp);
 
 kw = "addoval";
@@ -617,5 +621,5 @@
 usage += "\n  Related commands: addfoval addline addarrow addfrect addcirc addfcirc";
 usage += "\n       addcirc addfcirc addarc addfarc addpoly addfpoly graphicatt";  
-mpiac->RegisterCommand(kw, usage, this, "Graphic-Elts");
+mpiac->RegisterCommand(kw, usage, this, grp);
 
 kw = "addfoval";
@@ -628,5 +632,5 @@
 usage += "\n  Related commands: addoval addline addarrow addfrect addcirc addfcirc";
 usage += "\n       addcirc addfcirc addarc addfarc addpoly addfpoly graphicatt";  
-mpiac->RegisterCommand(kw, usage, this, "Graphic-Elts");
+mpiac->RegisterCommand(kw, usage, this, grp);
 
 kw = "addarca";
@@ -637,5 +641,5 @@
 usage += "\n  if fgnc==true : Normalized 0..1 coordinates specification (def=false)";
 usage += "\n  Related commands: addtext addline addfarca addarc ...";
-mpiac->RegisterCommand(kw, usage, this, "Graphic-Elts");
+mpiac->RegisterCommand(kw, usage, this, grp);
 
 kw = "addfarca";
@@ -646,5 +650,5 @@
 usage += "\n  if fgnc==true : Normalized 0..1 coordinates specification (def=false)";
 usage += "\n  Related commands: addtext addline addarca addarc ...";
-mpiac->RegisterCommand(kw, usage, this, "Graphic-Elts");
+mpiac->RegisterCommand(kw, usage, this, grp);
 
 kw = "addarc";
@@ -657,5 +661,5 @@
 usage += "\n  Related commands: addtext addline addarrow addfrect addfrect";
 usage += "\n       addcirc addfcirc addfarc addarca addpoly addfpoly graphicatt";  
-mpiac->RegisterCommand(kw, usage, this, "Graphic-Elts");
+mpiac->RegisterCommand(kw, usage, this, grp);
 
 kw = "addfarc";
@@ -668,5 +672,5 @@
 usage += "\n  Related commands: addtext addline addarrow addfrect addfrect";
 usage += "\n       addcirc addfcirc addfarc addpoly addfpoly graphicatt";  
-mpiac->RegisterCommand(kw, usage, this, "Graphic-Elts");
+mpiac->RegisterCommand(kw, usage, this, grp);
 
 kw = "addpoly";
@@ -677,5 +681,5 @@
 usage += "\n  Related commands: addtext addline addarrow addfrect addfrect";
 usage += "\n       addcirc addfcirc addfarc  graphicatt";  
-mpiac->RegisterCommand(kw, usage, this, "Graphic-Elts");
+mpiac->RegisterCommand(kw, usage, this, grp);
 
 kw = "addfpoly";
@@ -686,5 +690,5 @@
 usage += "\n  Related commands: addtext addline addarrow addfrect addfrect";
 usage += "\n       addcirc addfcirc addfarc  graphicatt";  
-mpiac->RegisterCommand(kw, usage, this, "Graphic-Elts");
+mpiac->RegisterCommand(kw, usage, this, grp);
 
 kw = "settitle";
@@ -711,4 +715,7 @@
 
 grp = "Obj. Display";
+gdesc = "Most useful commands to view and display objects ";
+mpiac->AddHelpGroup(grp, gdesc);
+
 kw = "disp";
 usage = "Displays an object \n Usage: disp nameobj [graphic_attributes]";
@@ -781,4 +788,5 @@
 mpiac->RegisterCommand(kw, usage, this, grp);
 
+// Importation/affichage fichier format PI-RGB
 kw = "pirgbdisp";
 usage = "Read and display RGB-image object (PIPixRGBArray) from file ";
@@ -787,4 +795,10 @@
 usage += "\n Related commands: win2rgb wdg2rgb ";  
 mpiac->RegisterCommand(kw, usage, this, grp);
+
+// Export to PI-RGB file
+grp = "GraphicExport";
+gdesc = "Commands to export graphics (widget/windows in postscript or PI-RGB image files";
+mpiac->AddHelpGroup(grp, gdesc);
+
 kw = "win2rgb";
 usage = " Export the current window to a PI-RGB file (.rgb)";
@@ -799,4 +813,5 @@
 
 // Ceci est maintenant obsolete, on garde pour info.
+grp = "Obj. Display";
 kw = "gfd2d";
 usage = "Displays Points (X-Y) with error-bars from a GeneralFit Data ";
Index: /trunk/SophyaPI/PIext/pawexecut.cc
===================================================================
--- /trunk/SophyaPI/PIext/pawexecut.cc	(revision 3550)
+++ /trunk/SophyaPI/PIext/pawexecut.cc	(revision 3551)
@@ -50,4 +50,6 @@
 string kw, usage;
 string hgrp = "pawCmd";
+string gdesc = "CERN PAW like expression plotting commands ";
+piac->AddHelpGroup(hgrp, gdesc);
 
 kw = "reset";