Index: trunk/SophyaLib/NTools/dates.cc
===================================================================
--- trunk/SophyaLib/NTools/dates.cc	(revision 3573)
+++ trunk/SophyaLib/NTools/dates.cc	(revision 3587)
@@ -112,5 +112,5 @@
   
   // Nous sommes dans un mois-frontiere
-  DBASSERT(dt.MM == dstStopMonth || dt.MM == dstStartMonth);
+  ASSERT(dt.MM == dstStopMonth || dt.MM == dstStartMonth);
   
   if (dt.MM == dstStartMonth) {
@@ -493,5 +493,5 @@
   
   if (tOpt == kLocalTime) {
-    DBASSERT(timeZone != NULL);
+    ASSERT(timeZone != NULL);
     operator -= (timeZone->gmtOffset/24.0);
     if (timeZone->IsDst(*this))
@@ -511,5 +511,5 @@
   Date dt(*this);
   if (tOpt == kLocalTime && !UndetTime()) {
-    DBASSERT(timeZone != NULL);
+    ASSERT(timeZone != NULL);
     dt += timeZone->GetOffset(*this)/24.0;
   }
@@ -535,5 +535,5 @@
   Date dt(*this);
   if (tOpt == kLocalTime && !UndetTime()) {
-    DBASSERT(timeZone != NULL);
+    ASSERT(timeZone != NULL);
     dt += timeZone->GetOffset(*this)/24.0;
   }
@@ -569,5 +569,5 @@
   Date dt(*this);
   if (tOpt == kLocalTime) {
-    DBASSERT(timeZone != NULL);
+    ASSERT(timeZone != NULL);
     dt += timeZone->GetOffset(*this)/24.0;
   }
@@ -628,5 +628,5 @@
   double t = GetDays();
   if (tOpt == kLocalTime && hh >=0) {
-    DBASSERT(timeZone != NULL);
+    ASSERT(timeZone != NULL);
     t += timeZone->GetOffset(*this)/24.0;
   }
Index: trunk/SophyaLib/NTools/generalfit.cc
===================================================================
--- trunk/SophyaLib/NTools/generalfit.cc	(revision 3573)
+++ trunk/SophyaLib/NTools/generalfit.cc	(revision 3587)
@@ -161,10 +161,5 @@
  ASSERT(mNPar<1000000);
 
- TRY {
-   General_Init();
- } CATCHALL {
-   THROW_SAME;
- } ENDTRY
-
+ General_Init();
 }
 
@@ -202,10 +197,5 @@
  ASSERT( mNPar < 1000000 );
 
- TRY {
-   General_Init();
- } CATCHALL {
-   THROW_SAME;
- } ENDTRY
-
+ General_Init();
 }
 
@@ -242,12 +232,13 @@
  GetIntEnv("PDEBUG_GENERALFIT",debugLevel);
 
- TRY {
+ try {
    fixParam   = new unsigned short int[mNPar];
    boundParam = new unsigned short int[mNPar];
    nameParam  = new string[mNPar];
- } CATCHALL {
+ }  
+ catch (...) {
    cout<<"GeneralFit::GeneralFit Impossible d'allouer l'espace"<<endl;
-   THROW_SAME;
- } ENDTRY
+   throw AllocationError("GeneralFit::GeneralFit() error allocating with new ...");
+} 
 
  Param        = (double)  0.;
@@ -910,17 +901,15 @@
 
    // Calcul de la matrice des covariances
-#ifdef __mac__
-   COVAR = SimpleMatrixOperation<r_8>::Inverse(ATGA); /* $CHECK$  Reza 10/3/2000 */
-#else
-   TRY {
+   try {
      COVAR = SimpleMatrixOperation<r_8>::Inverse(ATGA); /* $CHECK$  Reza 10/3/2000 */
-   } CATCHALL {
+   } 
+   catch (MathExc& exc) {
      if(debugLevel>0) {
+       cout<<"GeneralFit::Fit()/Exception:" << exc.what() << endl; 
        cout<<"Pb inversion matrice ATGA:"<<endl;
        cout<<ATGA;
      }
      return(-10);
-   } ENDTRY
-#endif
+  }
 
    if (debugLevel >= 3) {
Index: trunk/SophyaLib/NTools/integ.cc
===================================================================
--- trunk/SophyaLib/NTools/integ.cc	(revision 3573)
+++ trunk/SophyaLib/NTools/integ.cc	(revision 3587)
@@ -80,5 +80,5 @@
   mXMin(xmin), mXMax(xmax)
 {
-  DBASSERT(gff->NVar() == 1);
+  ASSERT(gff->NVar() == 1);
 }
 
@@ -94,5 +94,5 @@
   mXMin(0), mXMax(1)
 {
-  DBASSERT(gff->NVar() == 1);
+  ASSERT(gff->NVar() == 1);
 }
 
@@ -140,5 +140,5 @@
 Integrator::ReqPrec(double p)
 {
-  DBASSERT( !"Pas encore implemente !");
+  ASSERT( !"Pas encore implemente !");
   mReqPrec = p;
   mDX = mNStep = -1;
@@ -191,5 +191,5 @@
   mGFFParm = par;
   mFunc = NULL;
-  DBASSERT(gff->NVar() == 1);
+  ASSERT(gff->NVar() == 1);
   FuncChanged();
   return *this;
@@ -199,5 +199,5 @@
 Integrator::FVal(double x) const
 {
-  DBASSERT( mFunc || mClFun || (mGFF && mGFFParm) );
+  ASSERT( mFunc || mClFun || (mGFF && mGFFParm) );
   if (mFunc) return mFunc(x);
   else return mClFun ? (*mClFun)(x) : mGFF->Value(&x, mGFFParm); 