Index: trunk/AddOn/TAcq/dispbrpfft.pic
===================================================================
--- trunk/AddOn/TAcq/dispbrpfft.pic	(revision 3591)
+++ trunk/AddOn/TAcq/dispbrpfft.pic	(revision 3591)
@@ -0,0 +1,90 @@
+
+# Script pour lire un fichier FITS et afficher des lignes ( contenu des paquets)
+# Affichage adapte pour donnees FFT 2C
+# Appel  /Dev/AcquisBAO/Script/dispbrp.pic NomFichierFits CutRow CutCols
+delobjs *
+set sigo signal0
+set basedir /Raid/TestNancay_6avril2009/
+# set file TestFFT_$1/$sigo.fits
+set file $basedir/FFT_$1/$sigo.fits
+echo '----> Opening file ' $file
+readfits $file
+
+listobjs 
+set cutrow (r<1)
+set cutcol (c<5000)
+# sval=val a cause du c++exec
+#set sval ((val<127.5)?val:val-256.)
+set sval val
+if ( $# > 1 )  then 
+  set cutrow $2
+endif
+echo ' ---- CutRow= ' $cutrow
+if ( $# > 2 )  then 
+  set cutcol $3
+endif
+echo ' ---- CutCol= ' $cutcol ' PAS UTILISE'
+
+set sval ((val<127.5)?val:val-256.)
+mv ${sigo} sigdum
+c++exec \
+for(int i=0;i<sigdum.Size();i++)  sigdum[i] = (sigdum[i]<127.5)?sigdum[i]:sigdum[i]-256.;
+mv sigdum ${sigo}
+
+setaxesatt 'font=helvetica,bold,16 autofontsize=0.05 minorticks'
+zone 1 2
+#  r : numero de ligne ds le fichier -> numero de paquet
+#  c : numero de colonne -> numero d'echantillon dans le paquet  c=0...23 : entete  
+# plot2d $sigo c val ${cutrow}&&c>25 'blue'
+# plot2d $sigo c val ${cutrow}&&c>3000&&c<4500 'blue'
+# plot2d $sigo c (val<127.5)?val:val-256. ${cutrow}&&$cutcol 'blue connectpoints'
+# setaxelabels 'Num.Echantillon' 'Valeur Echantillon' 'font=helvetica,bolditalic,16' 
+# settitle 'Affichage Donnees brutes ' ' ' 'font=helvetica,bold,16'
+
+#fmax = 250.02
+#fmin = -0.02
+fmax = 4095.5*500./8192.
+fmin = -0.5*500./8192.
+#  FFT8K -> N=8192 echantillons en temps ==> N/2 frequences
+
+
+ntimesample = 8192
+nfreq = $ntimesample/2
+
+defscript faithisto ' Appel faithisto Voie '
+  if ( $1 == '1' ) then
+    set tit V1 
+    set hval hvalV1
+    set spec specV1
+    cuttsv = $ntimesample+24
+    set cutts "((c>23.5)&&(c<$cuttsv))"
+    set freq "((c-23)/2)*(250./$nfreq)"
+  else 
+    set tit V2 
+    set hval hvalV2
+    set spec specV2
+    cuttsv = 2*$ntimesample+24    
+    set cutts "((c>($ntimesample+24))&&(c<$cuttsv))"
+    set freq "((c-23-$ntimesample)/2)*(250./$nfreq)"
+  endif
+  echo " hval= $hval spec= $spec cutts= $cutts" 
+  newh1d $hval 2 253 251  
+  projh1d $hval $sigo val 1. ${cutrow}&&${cutts}
+  newh1d $spec $fmin $fmax $nfreq 
+  projh1d $spec $sigo $freq $sval*$sval ${cutrow}&&${cutts}
+  disp $hval 'font=helvetica,bold,16 fixedfontsize' 
+  settitle  "Frame data value distribution 5<VaL<250 - $tit" ' ' 'font=helvetica,bold,16'
+  disp $spec 'font=helvetica,bold,16 fixedfontsize'
+  settitle " Spectra from Data $tit" ' ' ' font=helvetica,bold,16'
+endscript 
+
+plot2d $sigo c val ${cutrow}&&c>23 'blue font=helvetica,bold,16 fixedfontsize win'
+settitle  "Aff. frame data $1" ' ' 'font=helvetica,bold,16'
+
+zone 2 2 
+faithisto 1
+faithisto 2
+
+#n/plot specV1.10*log10(val)%x val>0
+#n/plot specV2.10*log10(val)%x val>0
+#disp signal0 "lut=lin,-1,1 imagecenter=4120,20"
Index: trunk/AddOn/TAcq/dispbrpraw.pic
===================================================================
--- trunk/AddOn/TAcq/dispbrpraw.pic	(revision 3591)
+++ trunk/AddOn/TAcq/dispbrpraw.pic	(revision 3591)
@@ -0,0 +1,29 @@
+
+# Script pour lire un fichier FITS et afficher des lignes ( contenu des paquets)
+# Appel  /Dev/AcquisBAO/Script/dispbrp.pic NomFichierFits CutRow CutCols
+delobjs *
+set sigo signal0
+set basedir /Raid/TestNancay_6avril2009/
+# set file $1/$sigo.fits
+set file $basedir/Raw_$1/$sigo.fits
+
+echo '----> Opening file ' $file
+readfits $file
+
+listobjs 
+set cutrow (r<1)
+set cutcol (c<5000)
+if ( $# > 1 )  then 
+  set cutrow $2
+endif
+echo ' ---- CutRow= ' $cutrow
+if ( $# > 2 )  then 
+  set cutcol $3
+endif
+echo ' ---- CutCol= ' $cutcol ' PAS UTILISE'
+
+
+setaxesatt 'font=helvetica,bold,16 autofontsize=0.05 minorticks'
+zone 1 2
+
+plot2d $sigo c val ${cutrow}&&c>23 'blue font=helvetica,bold,16 fixedfontsize connectpoints win'
Index: trunk/AddOn/TAcq/makefile
===================================================================
--- trunk/AddOn/TAcq/makefile	(revision 3576)
+++ trunk/AddOn/TAcq/makefile	(revision 3591)
@@ -1,8 +1,9 @@
 include $(SOPHYABASE)/include/sophyamake.inc
 
-all : traidio  tmtfft tstminifits tpciew tbrpaq tmtacq tstrdfits mfits2spec tsok
+all : traidio  tmtfft tstminifits tpciew tbrpaq tmtacq tstrdfits mfits2spec tsok sigana
 
 clean :
-	rm *.o traidio tmtfft tstminifits tpciew tbrpaq tmtacq tstrdfits mfits2spec tsok *.ppf *.fits 
+	rm *.o traidio tmtfft tstminifits tpciew tbrpaq tmtacq tstrdfits 
+	rm mfits2spec tsok sigana *.ppf *.fits 
 
 ########################################################
@@ -45,4 +46,10 @@
 
 ##   --------------
+sigana : sigana.o sigana.o
+	$(CXXLINK) -o sigana sigana.o minifits.o  $(SOPHYAEXTSLBLIST)
+
+sigana.o : sigana.cc minifits.h
+	$(CXXCOMPILE) -o sigana.o sigana.cc
+
 mfits2spec : mfits2spec.o minifits.o
 	$(CXXLINK) -o mfits2spec mfits2spec.o minifits.o  $(SOPHYAEXTSLBLIST)